"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
const index_1 = require("./index");
const aDate = (x) => {
    if (util_1.isNil(x)) {
        throw new index_1.ParserError("date", x);
    }
    if (x instanceof Date) {
        return x;
    }
    if (typeof x === "string") {
        const millis = Date.parse(x);
        if (!Number.isNaN(millis)) {
            return new Date(millis);
        }
    }
    throw new index_1.ParserError("date", typeof x);
};
exports.default = aDate;
