"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
const index_1 = require("./index");
const fromObject = (object, key, valueParser) => {
    if (util_1.isNil(object)) {
        throw new index_1.ParserError("Object", object);
    }
    if (typeof object !== "object") {
        throw new index_1.ParserError("Object", object);
    }
    if (!(key in object)) {
        throw new index_1.ParserError(`Object containing key ${key}`, JSON.stringify(object));
    }
    return valueParser(object[key]);
};
exports.default = fromObject;
