"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = exports.ParserError = exports.or = exports.aNull = exports.withObject = exports.aString = exports.aNumber = exports.fromObject = exports.aDate = exports.aBoolean = exports.anArrayContaining = void 0;
const array_1 = require("./array");
exports.anArrayContaining = array_1.default;
const boolean_1 = require("./boolean");
exports.aBoolean = boolean_1.default;
const date_1 = require("./date");
exports.aDate = date_1.default;
const fromObject_1 = require("./fromObject");
exports.fromObject = fromObject_1.default;
const null_1 = require("./null");
exports.aNull = null_1.default;
const number_1 = require("./number");
exports.aNumber = number_1.default;
const or_1 = require("./or");
exports.or = or_1.default;
const string_1 = require("./string");
exports.aString = string_1.default;
const withObject_1 = require("./withObject");
exports.withObject = withObject_1.default;
/**
 * A `ParseFn` throws a `ParseError` when the `ParseInput` cannot be transformed to the parsers target type.
 */
class ParserError extends Error {
    constructor(expected, found) {
        super(`Expected ${expected} but found ${found}`);
        this.expected = expected;
        this.found = found;
    }
}
exports.ParserError = ParserError;
/**
 * Syntactic sugar to lazy invoke a `ParseFn`; Creates a new `ParseFn` with given parser and returns it for later
 * invocation.
 */
const parse = (parser) => (x) => parser(x);
exports.parse = parse;
