"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const util_1 = require("../util");
/**
 * Tries to parse an object. When object is present, provided `fn` is called with the object as first parameter.
 *
 * @param fn
 * @returns
 */
function withObject(fn) {
    return (x) => {
        if (util_1.isNil(x)) {
            throw new _1.ParserError("Object", x);
        }
        if (Object.prototype.toString.call(x) !== "[object Object]") {
            throw new _1.ParserError("Object", x);
        }
        return fn(x);
    };
}
exports.default = withObject;
